let add (n : GPack.notebook) e =
  ignore (n#insert_page ~pos:0 ~tab_label:e#label#coerce e#coerce);
  n#set_tab_reorderable e#coerce true

let sink ~tabs ~nouveau = function
  | `RemoveIndex i -> tabs#remove_page i
  | `Add (_, _, e) -> add tabs (nouveau e)
  | `Nth i -> tabs#goto_page i
  | `None -> ()

let tabs ?packing ~core ~nouveau =
  let tabs = GPack.notebook ?packing ~scrollable:true () in
  core#connect (sink ~tabs ~nouveau);
  tabs

